
; Processor:        K1801VM1
; Target assembler: BK Turbo8 Assembler

; ═══════════════════════════════════════════════════════════════════════════

                br      Detect
; ───────────────────────────────────────────────────────────────────────────
;перехватчик EMT для бейсика
EMTT$:          mov     R5, -(SP)
                mov     2(SP), R5       ;адрес возврата из прерывания
                mov     -(R5), R5       ;получим код команды EMT
                cmp     #104036, R5     ;это EMT 36
                beq     0E36$           ;да - пойдём перехватим
                cmp     #104014, R5     ;это EMT 14
                bne     1$              ;нет - остальные EMT обрабатываем как обычно
                mov     @#122, -(SP)    ;перехватим EMT 14
                mov     @#124, -(SP)    ;сохраним ключи
                call    @#100140        ;выполним инициализацию
                mov     #EMTT$, @#30    ;восстановим перехватчик EMT
                mov     (SP)+, @#124    ;восстановим ключи
                mov     (SP)+, @#122
                br      0QUIT
; ───────────────────────────────────────────────────────────────────────────

1$:             jmp     @#100122        ;обычное выполнение EMT диспетчера
; ───────────────────────────────────────────────────────────────────────────
; перехват емт 36
0E36$:          jsr     R5, SetMode     ;устанавливаем режим СМК
stdmode:        .word   60, 0           ;стр.0, стандартный для ОС
                cmpb    @#345, #32      ;имя файла кончается на ^Z ?
                beq     2$              ;да - обычная дисковая операция
                cmpb    (R1), #4        ;команда "фиктивное чтение"?
                bne     3$              ;нет
                ;да - значит бейсиковский FIND
                cmp     @#326, #"EX     ;ищем файл "EXIT"?
                bne     2$
                cmp     @#330, #"IT
                beq     4$              ;да - значит выход 

2$:             mov     #334, R5        ;формируем имя в стандартах АНДОС
                mov     #20040, (R5)    ;6 символов имя, потом 4 пробела
                mov     (R5)+, (R5)+
                tstb    @#120154        ;какое текущее устройство (0-@:, 1-32 - A:-Z:)?
                beq     3$              ;0 - магнитофон
                cmpb    @#345, #32      ;нет- диски, а имя файла кончается на ^Z ?
                bne     3$              ;нет
                mov     #" ., (R5)      ;да - добавим точку
                movb    (R5), @#345     ;и ^Z заменим на пробел
3$:             call    @#120002        ;выполняем дисковую операцию
                jsr     R5, SetMode     ;устанавливаем режим СМК
                .word   2020, 14        ;стр.1 режим 20, в конце подключаем ПЗУ
                                        ;бейсика на БК10 - код 10 (это работает только на
                                        ;оригинальных СМК 64, на репликах отключено.)
                                        ;и запрещаем порты 177130,177132 по чтению - код 4
0QUIT:          mov     (SP)+, R5
                rti

4$:             emt     130             ;выход в оболочку АНДОС
; ───────────────────────────────────────────────────────────────────────────
;переключение режима работы СМК
SetMode:        mov     #6, @#177130
                mov     (R5)+, @#177130
                mov     (R5)+, @#177130
                rts     R5
; ───────────────────────────────────────────────────────────────────────────
;вся дальнейшая фигня для работы с бейсиком не нужна

Start:          mov     #400, R0        ;какая-то таинственная возня с командной строкой
                mov     #200, R5        ;что делается, мне не интересно

7$:             cmpb    #56, (R0)+  ; '.'
                bne     5$
                cmpb    #103, (R0)  ; 'C'
                beq     6$
                cmpb    #60, (R0)   ; '0'
                beq     6$
                cmpb    #102, (R0)  ; 'B'
                beq     6$
                cmpb    #40, (R0)   ; ' '
                beq     6$

5$:             sob     R5, 7$
                br      8$

6$:             dec     R0
                mov     R0, R1
                sub     #4, @#122
                cmp     (R1)+, (R1)+
9$:             movb    (R1)+, (R0)+
                sob     R5, 9$

8$:             mov     #EMTT$, @#30    ;перехватываем обработчик EMT
                jsr     R5, SetMode     ;устанавливаем режим СМК
                .word   2020, 14
                mtps    #0
                jmp     @#120000        ;запускаем бейсик

; ───────────────────────────────────────────────────────────────────────────
;дальше идёт мой код.
; ───────────────────────────────────────────────────────────────────────────

;определяем
Detect:         mtps    #377
                mov     #6, R5
                mov     #340, (R5)
                mov     -(R5), OV4      ;сохраним вектор 4
                ;проверим на АНДОС
                mov     #120170, R0     ;Версия ANDOS (для V3.1 - 100466)
                cmp     (R0), #100000 + 330.
                bhi     0ERROS
                cmp     (R0), #100000 + 223.
                bhis    0OKOS
0ERROS:         jsr     R1, StringOutI  ;скажем, что ОС не подходит
                .asciz  "Программа работает только в ANDOS v2.23 и выше!"<12>
                .even
QuitToOS:       call    VKLSTD
                jsr     R1, StringOutI
                .asciz  "Нажмите любую клавишу..."
                .even
1$:             bit     #100, @#177716
                beq     1$
2$:             bit     #100, @#177716
                bne     2$
                mov     OV4, @#4
                halt

0OKOS:          ;проверим на БК11М
                mov     #BK10OK, (R5)   ;зададим свой вектор 4
                mov     #42400, @#177662
                mov     #100140, stdmode ;стандартный режим для БК11 и признак БК11 в знаковом бите
BK10OK:         mov     OV4, (R5)       ;восстановим вектор 4
                call    Identify        ;проверка на СМК
                mov     OV4, @#4        ;снова восстановим вектор 4
                call    Prepare         ;загрузка бейсика в ОЗУ СМК
                call    Control         ;проверим, что в ОЗУ СМК творится
                beq     3$
                jsr     R1, StringOutI
                .asciz  "Что-то пошло не так."<12>
                .even
                ;call    Debug
                br      QuitToOS

3$:             call    @#100140        ;выполним инициализацию
                jmp     Start

;дальше нам это понадобится
SetBAS10:       jsr     R5, SetMode     ;устанавливаем режим СМК
                .word   2020, 14
                return
;вывод inline строки
;вызов: jsr r1,StringOutI
;       .asciz "str"
;       .even
StringOutI:     clr     R2
                emt     20
                inc     R1
                bic     #1, R1
                rts     R1
;вывод строки, адрес которой - параметр за командой
;вызов: jsr r5,StringOut
;       .word   StrAddr
StringOut:      mov     (R5)+, R1
;вывод строки, адрес которой - параметр в регистре R1
;вызов: jsr r5,StringOut1
StringOut1:     clr     R2
                emt     20
                rts     R5

;расчёт контрольной суммы
;вход:  R5 - адрес массива
;       R4 - длина массива в словах
;выход: R0 - контрольная сумма
CheckSum:       push    R5
                push    R4
                clr     R0
1$:             add     (R5)+, R0
                adc     R0
                sob     R4,1$
                pop     R4
                pop     R5
                return

;теперь надо подготовить всё.
; в режиме 20 в стр 1 надо загружать бейсик
Prepare:
;1 скопируем монитор
                mov     #10000,R3       ;длина в словах
                tst     stdmode
                bpl     0BK10
                ;на БК11  свой метод, сперва надо скопировать монитор со своего места
                ;в буфер
                mov     #100000,R1
                mov     #20000,R5       ;адрес начала массива
                mov     R5,R0
                mov     R3,R4
11$:            mov     (R1)+,(R0)+
                sob     R4,11$
                ;теперь скорректируем контрольную сумму, чтобы -1 было
                mov     R0, R2
                mov     #20000, R5      ;адрес начала массива
                mov     R3, R4          ;длина в словах
                call    CheckSum        ;считаем кс монитора
                mov     #-1, R1
                sub     R0, R1
                add     R1, -(R2)
                br      12$

0BK10:          mov     #100000,R5      ;адрес начала массива
12$:            mov     R3,R4           ;длина в словах
                call    CheckSum        ;считаем кс монитора
                mov     R0,CSMON10      ;сохраняем
                mov     #2060,R0        ;стр 1 режим 60
                call    VKL
                mov     #140000,R0      ;скопируем в сегменты 4,5
1$:             mov     (R5)+,(R0)+
                sob     R4,1$
                call    VKLSTD

;загружаем первое ПЗУ бейсика
                mov     #320,R1
                mov     R1,R0
                mov     #3,(R0)+        ;читаем
                mov     #20000,(R0)     ;по этому адресу
                mov     (R0)+,(R0)+     ;так совпало, что длина тоже такая же
                mov     #ROMBAS1Name,R2 ;копируем имя файла
2$:             movb    (R2)+,(R0)+
                bne     2$
                dec     R0              ;остаток забиваем пробелами
4$:             movb    #40,(R0)+
                cmp     R0,#346
                blo     4$
                emt     36              ;читаем
                tstb    1(R1)           ;если не прочиталось
                bne     STOP0$          ;выходим с ошибкой
                mov     #20000,R5       ;адрес начала массива
                mov     R3,R4           ;длина в словах
                call    CheckSum        ;считаем кс первого ПЗУ бейсика
                mov     R0,CSBAS10.1    ;сохраняем
                mov     #2160,R0        ;стр 1 режим 160
                call    VKL
                mov     #120000,R0      ;скопируем в сегменты 6,7
3$:             mov     (R5)+,(R0)+
                sob     R4,3$
                call    VKLSTD

;загружаем второе ПЗУ бейсика
                incb    6+11(R1)
                emt     36
                tstb    1(R1)
                bne     STOP0$
                mov     #20000,R5       ;адрес начала массива
                mov     R3,R4           ;длина в словах
                call    CheckSum        ;считаем кс второго ПЗУ бейсика
                mov     R0,CSBAS10.2    ;сохраняем
                mov     #2160,R0        ;стр 1 режим 160
                call    VKL
                mov     #140000,R0      ;скопируем в сегменты 0,1
5$:             mov     (R5)+,(R0)+
                sob     R4,5$
                call    VKLSTD

;загружаем третье ПЗУ бейсика
                mov     #20000,R2       ;ПЗУ не до конца, поэтому хвост надо обнулить
                mov     #10000,R0
6$:             clr     (R2)+
                sob     R0, 6$
                incb    6+11(R1)
                emt     36
                tstb    1(R1)
                bne     STOP0$
                mov     #20000,R5       ;адрес начала массива
                mov     R3,R4           ;длина в словах
                call    CheckSum        ;считаем кс третьего ПЗУ бейсика
                mov     R0,CSBAS10.3    ;сохраняем
                mov     #2060,R0        ;стр 1 режим 60
                call    VKL
                mov     #120000,R0      ;скопируем в сегменты 2,3
8$:             mov     (R5)+,(R0)+
                sob     R4,8$
                call    VKLSTD
                return
STOP0$:         jmp     QuitToOS


CSMON10:        .word   0
CSBAS10.1:      .word   0
CSBAS10.2:      .word   0
CSBAS10.3:      .word   0
CSStaus:        .byte   0,0,0,0 ;флаги совпадений КС

ROMBAS1Name:    .asciz  "BASROM10.1"
                .even

;прежде чем запускать что-то проконтролируем, а что там у нас вообще получилось
Control:        call    SetBAS10        ;устанавливаем режим СМК
                ;посчитаем контрольные суммы
Control2:       mov     #CSStaus,R3
                mov     #100000,R5      ;адрес начала
                mov     #10000,R4       ;длина массива
                call    CheckSum
                cmp     R0,CSMON10
                beq     0ok$
                incb    (R3)
0ok$:           inc     R3
                add     R4,R5
                add     R4,R5
                call    CheckSum
                cmp     R0,CSBAS10.1
                beq     1ok$
                incb    (R3)
1ok$:           inc     R3
                add     R4,R5
                add     R4,R5
                call    CheckSum
                cmp     R0,CSBAS10.2
                beq     2ok$
                incb    (R3)
2ok$:           inc     R3
                add     R4,R5
                add     R4,R5
                sub     #100,R4         ;последнее ПЗУ на 100 слов короче
                call    CheckSum
                cmp     R0,CSBAS10.3
                beq     3ok$
                incb    (R3)
3ok$:           inc     R3
TestMode:       nop
                call    VKLSTD
                ;теперь сообщим, что получилось
                clr     R5
                mov     #CSStaus,R3
                tstb    (R3)+
                beq     00ok$
                jsr     R1,StringOutI
                .asciz  "Контрольная сумма Монитора БК10 не совпадает"<12>
                .even
                inc     R5
00ok$:          tstb    (R3)+
                beq     10ok$
                jsr     R1,StringOutI
                .asciz  "Контрольная сумма ПЗУ 1 Бейсика БК10 не совпадает"<12>
                .even
                inc     R5
10ok$:          tstb    (R3)+
                beq     20ok$
                jsr     R1,StringOutI
                .asciz  "Контрольная сумма ПЗУ 2 Бейсика БК10 не совпадает"<12>
                .even
                inc     R5
20ok$:          tstb    (R3)+
                beq     30ok$
                jsr     R1,StringOutI
                .asciz  "Контрольная сумма ПЗУ 3 Бейсика БК10 не совпадает"<12>
                .even
                inc     R5
30ok$:          tst     R5
                return



;Debug:          mov     #160000,R5      ;адрес в ОЗУ СМК
;                mov     #20000,R4       ;адрес в буфере
;                mov     #7700,R3        ;количество слов
;                call    SetBAS10        ;устанавливаем режим СМК
;2$:             cmp     (R5)+,(R4)+
;                beq     1$
;                mov     -(R5),R2        ;берём не совпавшее слово
;                call    VKLSTD          ;включим стандартный режим, чтобы текст вывести
;                mov     R5,R1           ;адрес не совпавшего слова
;                call    D6OUT3
;                mov     #':,R0          ;через двоеточие
;                emt     16
;                mov     R2,R1           ;само не совпавшее слово
;                call    D6OUT3
;                mov     #" -,R0
;                emt     16
;                swab    R0
;                emt     16
;                swab    R0
;                emt     16
;                mov     -(R4),R1        ;а затем, что должно быть
;                call    D6OUT3
;                mov     #12,R0
;                emt     16
;                cmp     (R5)+,(R4)+     ;двигаем указатели обратно
;                call    SetBAS10        ;устанавливаем режим СМК
;1$:             sob     R3,2$
;                call    VKLSTD
;                return
;
;Dump:           mov     #177600, R2
;                mov     #8.,R4
;4$:             mov     R2, R1
;                call    D6OUT3
;                mov     #':,R0
;                emt     16
;                mov     #8., R3
;1$:             mov     (R2)+, R1
;                call    D6OUT3
;                cmp     R3,#1
;                bne     2$
;                mov     #12,R0
;                br      3$
;2$:             mov     #40,R0
;3$:             emt     16
;                sob     R3,1$
;                sob     R4,4$
;                return


Identify:       ;определяем тип контроллера и кол-во памяти по значению в 167776
                clr     VALUE1          ;флаг, что не найден контроллер альтпро
                mov     @#167776,R5     ;в мл. байте версия прошивки
                mov     R5,R0
                clrb    R0
                bic     R0,R5
                swab    R0              ;в мл байте код количества памяти
                cmpb    R0,#370
                blo     0$
                mov     #CODES,R3
                clr     R4
2$:             tstb    (R3)
                beq     0$
                cmpb    R0,(R3)+
                beq     1$
                inc     R4
                br      2$

0$:             jsr     R5,StringOut
                .word   NOALTP
                jmp     QuitToOS

1$:             ;нашли
                mov     #4,R3
                cmp     R4,R3           ;для а16 нечего делать
                blo     3$              ;а если smk или a64m, надо определить, что это
                cmpb    R5,#300
                bhis    3$
                comb    SMKHDD
                add     R3,R4
3$:             asl     R4
                jsr     R5,StringOut
                .word   FOUND
                mov     NMTBL(R4),R1    ;выведем имя контроллера
                jsr     R5,StringOut1
                mov     #VERS,R1        ;выведем версию, в нечеловекообразном виде
                jsr     R5,StringOut1
                mov     R5,R1
                call    DGOUT           ;вывод числа из R1, с подавлением ведущих нулей
                mov     #12,R0
                emt     16
                ;теперь проверим какая прошивка, будем просто использовать кусок теста режимов.
SYNCW=55000
                cmp     R4,#10          ;если это не СМК
                blo     15$             ;то прошивку проверять не надо
                mov     #AH,@#4
                mov     #100,R0         ;код режима
                mov     #SYNCW,R2       ;проверочное слово
                mov     #160172,R3      ;адрес для проверки
                clr     R5
                call    DTOLD
                cmp     #4,R0
                bne     10$
                inc     R5
10$:            mov     #120,R0
                mov     #177172,R3
                call    DTOLD
                cmp     #11,R0
                bne     11$
                inc     R5
11$:            call    VKLSTD
                jsr     R5,StringOut
                .word   VERRT
                tst     R5
                bne     12$
                mov     #RTOK,R1
                br      14$

12$:            comb    VALUE1          ;отметим, что прошивка неправильная
                cmp     #2,R5
                bne     13$
                mov     #RTBAD,R1
                br      14$
13$:            mov     #RTERR,R1
14$:            jsr     R5,StringOut1
15$:            return

VKLSTD:         mov     stdmode,R0
VKL:            mov     @#4, BufV4
                mov     #TRST30,@#4     ;прер по вектору 4 просто будем игнорировать.
                mov     #6,@#177130
                mov     R0,@#177130
                mov     #0,@#177130
                mov     BufV4, @#4
                return
BufV4:          .word 0

AH:             ;обработка halt для теста режимов
                add     #4,(SP)
TRST30:         rti                     ;продолжим тесты, как будто ничего не было

DTOLD:          mov     R0,-(SP)
                mov     #20,R0          ;включаем режим 20, чтобы вписать куда нужно проверочное слово
                call    VKL             ;чтобы алгоритм из теста режимов срабатывал стандартно
                mov     R2,-40000(R3)
                mov     (SP)+,R0        ;устанавливаем нужный режим
                call    VKL             ;включение режима без учета типа БК, вход: R0 - код режима
                clr     R0              ;тут накапливается код результата теста
                cmp     R2,(R3)         ;тестируем, есть ли доступ по чтению
                bne     3$
                beq     4$
                cmp     (R0)+,(R0)+     ;<-halt сюда для cmp
4$:             cmp     (R0)+,(R0)+
                ;зесь R0 == 0, 4, 010 при !=, =, halt
3$:             mov     R3,(R3)         ;тестируем, есть ли доступ по записи
                cmp     R2,(R3)         ;тестируем, работает ли запись как надо
                beq     6$              ;если запись прошла, но по чтению все равно изначальный вариант
                nop                     ;<-halt сюда для mov
                mov     R2,(R3)         ;<-halt сюда для cmp
                cmp     R2,(R3)
                br      5$
                br      1$              ;<-halt сюда для mov
5$:             bne     6$              ;<-halt сюда для cmp - !=
                inc     R0              ;write
6$:             inc     R0              ;nowr
1$:             return


;вывод числа из R1, без подавления ведущих нулей
D6OUT3:         jsr		R5,PUSHA
                mov 	#6,R4	;максимальное кол-во цифр в числе
                br		DGOUT$
;вывод 4-х значного числа из R1, без подавления ведущих нулей
D4OUT3:         jsr		R5,PUSHA
                mov 	#4,R4	;максимальное кол-во цифр в числе
DGOUT$:         mov		R4,R5	;счётчик цифр
0$:             mov 	R1,R0
                bic 	#177770,R0	;получим очередную цифру
                add 	#'0,R0
                mov 	R0,-(SP)	;в стек её
                ror 	R1		;пододвинем следующую, ADD бит С обнуляет, так что можно
                asr 	R1
                asr 	R1		;цифры остались?
                sob 	R4,0$
1$:             mov 	(SP)+,R0
                emt	    16	;вывод символа на экран. Вход: R0 - код символа
                sob 	R5,1$
                return
;вывод числа из R1, с подавлением ведущих нулей
DGOUT:          jsr		R5,PUSHA
                mov 	#6,R4	;максимальное кол-во цифр в числе
                clr		R5		;счётчик цифр
0$:             mov 	R1,R0
                bic 	#177770,R0	;получим очередную цифру
                add 	#'0,R0
                mov 	R0,-(SP)	;в стек её
                inc		R5
                ror 	R1		;пододвинем следующую, ADD бит С обнуляет, так что можно
                asr 	R1
                asr 	R1		;цифры остались?
                beq		1$		;кончились - выход, если число отрицательное, то мы отработает все 6 цифр.
                sob 	R4,0$
1$:             mov 	(SP)+,R0
                emt 	16	;вывод символа на экран. Вход: R0 - код символа
                sob 	R5,1$
                return

;вызов так: jsr r5,pusha, сохраняем все регистры
;но в r5 нельзя передать параметр, чтобы было можно, есть более сложный метод
PUSHA:          mov     R4,-(SP)
                mov     R3,-(SP)
                mov     R2,-(SP)
                mov     R1,-(SP)
                mov     R0,-(SP)
                ;mov    R5,-(SP) ;это - чтобы и в r5 можно было
                ;mov    14(SP),R5       ;передавать параметры
                ;call   @(SP)+
                call    (R5)
                mov     (SP)+,R0
                mov     (SP)+,R1
                mov     (SP)+,R2
                mov     (SP)+,R3
                mov     (SP)+,R4
                mov     (SP)+,R5
                return

OV4:            .word   0               ;буфер сохранения вектора 4
VALUE1:         .byte   0
SMKHDD:         .byte   0

;коды для подключения страниц памяти
RAMCOD:         .WORD 160       ;0     (код 0)
C016:           .WORD 60
C032:           .WORD 2160      ;+32Кб (код 2000)
                .WORD 2060
C064:           .WORD 164       ;+64Кб (код 4)
                .WORD 64
                .WORD 2164      ;+96Кб (код 2004)(64+32)
                .WORD 2064
C128:           .WORD 170       ;+128Кб (код 10)
                .WORD 70
                .WORD 2170      ;+160Кб (код 2010)(128+32)
                .WORD 2070
                .WORD 174       ;+192Кб (код 14)(128+64)
                .WORD 74
                .WORD 2174      ;+224Кб (код 2014)(128+64+32)
                .WORD 2074
; это для 512Кб (вторая половина)
C256:           .WORD 161       ;+256Кб (код 1)
                .WORD 61
                .WORD 2161      ;+288Кб (код 2001)(256+32)
                .WORD 2061
                .WORD 165       ;+320Кб (код 5)(256+64)
                .WORD 65
                .WORD 2165      ;+352Кб (код 2005)(256+64+32)
                .WORD 2065
                .WORD 171       ;+384Кб (код 11)(256+128)
                .WORD 71
                .WORD 2171      ;+416Кб (код 2011)(256+128+32)
                .WORD 2071
                .WORD 175       ;+448Кб (код 15)(256+128+64)
                .WORD 75
                .WORD 2175      ;+480Кб (код 2015)(256+128+64+32)
                .WORD 2075
C512:           .WORD 0

TZCTB:          .WORD   C016-RAMCOD
                .WORD   C016-RAMCOD
                .WORD   C016-RAMCOD
                .WORD   C016-RAMCOD
                .WORD   C064-RAMCOD
                .WORD   C128-RAMCOD
                .WORD   C256-RAMCOD
                .WORD   C512-RAMCOD
                .WORD   C064-RAMCOD
                .WORD   C128-RAMCOD
                .WORD   C256-RAMCOD
                .WORD   C512-RAMCOD

NMTBL:          .WORD   NA16
                .WORD   NA16H
                .WORD   NA16M
                .WORD   NAUNK
                .WORD   NA64M
                .WORD   NA128M
                .WORD   NA256M
                .WORD   NA512M
                .WORD   NS64
                .WORD   NS128
                .WORD   NS256
                .WORD   NS512
;коды в ячейке 167777, определяющие тип контроллера
CODES:          .BYTE   370     ;A16
                .BYTE   371     ;A16+контроллера винта с дозу 4кб
                .BYTE   372     ;A16M
                .BYTE   373     ;не исп-ся
                .BYTE   374     ;SMK64 или A64M
                .BYTE   375     ;SMK128 или A128M
                .BYTE   376     ;SMK256 или A256M
                .BYTE   377     ;SMK512 или A512M
                .BYTE   0
;имена контроллеров
NA16:           .ASCIZ  "A16"
NA16H:          .ASCIZ  "A16HDD"
NA16M:          .ASCIZ  "A16M"
NAUNK:          .ASCIZ  "Несуществующий"
NA64M:          .ASCIZ  "A64M"
NA128M:         .ASCIZ  "A128M"
NA256M:         .ASCIZ  "A256M"
NA512M:         .ASCIZ  "A512M"
NS64:           .ASCIZ  "SMK64"
NS128:          .ASCIZ  "SMK128"
NS256:          .ASCIZ  "SMK256"
NS512:          .ASCIZ  "SMK512"
NOALTP:         .ASCIZ  "Не обнаружен контроллер АльтПро"<12>
FOUND:          .ASCIZ  "Обнаружен контроллер "
VERS:           .ASCIZ  " версия прошивки: "
VERRT:          .ASCIZ  "Версия прошивки 555РТ5: "
RTOK:           .ASCIZ  "новая"<12>
RTBAD:          .ASCIZ  "старая, не рекомендуется к использованию"<12>
RTERR:          .ASCIZ  "повреждена."<12>

                .even

                .END
